#! /usr/bin/env python
# -*- coding: utf8 -*-
#
# Free Volume 0.2
# - autor puvodni verze (radek@fastlinux.eu)
# - na verzi 0.2 pozmenil (uiii@centrum.cz)
#
# Zalozeno na programu VolumeControl 0.1 (Mayguz@web.de)
#  	
# *** Nove ve verzi 0.2 ***
# - reaguje na zmenu hlasitosti jinymy programy
# - upraven vzhled (presunut ciselny ukazatel hlasitosti)
#
# *** Pozadavky ***
#	python
#	pygtk
#	aumix
# 	gtk
#

import os
import gtk.glade
import gtk
import sys
import gobject

# --------------- class VolumeGui -----------------------

class VolumeGui:
	
	def __init__(self):
		self.gladefile = sys.path[0] + "/vol_gui.glade"
		self.wTree = gtk.glade.XML(self.gladefile)
		self.VolumeBox = self.wTree.get_widget("VolumeGui")
		self.volume_scale = self.wTree.get_widget("VolumeScale")
		self.volume_label = self.wTree.get_widget("VolumeLabel")
		self.toggle = self.wTree.get_widget("MuteButton")
		self.set_signals()
		self.is_mute = False
		self.get_system_volume()
		
	def set_signals(self):
		signal_dictonary = { "on_VolumeScale_value_changed" : self.scale,
							 "on_MuteButton_toggled": self.mute,
							 "on_VolumeGui_focus_out_event" : self.focus_lost }
		
		self.wTree.signal_autoconnect(signal_dictonary)
	
	def focus_lost(self, one, two):
		self.VolumeBox.hide()
	
	def scale(self, data):
		self.set_system_volume()
		self.volume_label.set_text(str(self.volume))

	def show(self):
		self.get_system_volume()
		self.volume_label.set_text(str(self.volume))
		self.volume_scale.set_value(float(self.volume))
		self.VolumeBox.show_all()
	
	def mute(self, data):
		if(self.toggle.get_active()):
			self.is_mute = True
			set_m = "aumix -v 0"
		else:
			self.is_mute = False
			set_m = "aumix -v " + str(self.volume)
		
		os.system(set_m)
		
	def get_system_volume(self):
		is_v = os.popen("aumix -vq").readlines()
		is_v = int(is_v[0].split(',')[1].strip(' '))
		if(self.is_mute == False):
			self.volume = is_v
		elif(self.is_mute == True and is_v != 0):
			self.volume = is_v
			self.toggle.set_active(False)
		
	def set_system_volume(self):
		self.volume = int(self.volume_scale.get_value())
		if(self.is_mute == False):
			set_v = "aumix -v " + str(self.volume)
			os.system(set_v)

# ------------------------ class TrayIcon -------------------------------

class TrayIcon(gtk.StatusIcon, VolumeGui):
	
	def __init__(self):
		gtk.StatusIcon.__init__(self)
		VolumeGui.__init__(self)
		icon_path = sys.path[0] + "/audio-volume-high.png"
		self.set_visible(True)
		self.set_from_file(icon_path)
		self.set_tooltip("FreeVolume")
		self.manager = gtk.UIManager()
		self.createActions()
		self.createMenu()
		self.connect('activate', self.on_activate)
		self.connect('popup-menu', self.on_popup_menu)
		
	def on_activate(self, data):
		if(self.VolumeBox.is_active()):
			self.VolumeBox.hide()
		else:
			self.show()
			
	def on_popup_menu(self, status, button, time):
		self.menu.popup(None, None, None, button, time)
	
	def createMenu(self):
		menu = '''
			<ui>
				<menubar name="Menubar">
					<menu action="Menu">
						<menuitem action="O Programu"/>
						<menuitem action="Konec"/>
					</menu>
				</menubar>
			</ui>
		'''
		self.manager.add_ui_from_string(menu)
		self.menu = self.manager.get_widget('/Menubar/Menu/O Programu').props.parent

	def createActions(self):
		actions = [
			('Menu',  None, 'Menu'),
			('O Programu', gtk.STOCK_ABOUT, '_O Programu', None, 'O Programu', self.on_about),
			('Konec', gtk.STOCK_QUIT, '_Konec', None, 'Konec aplikace', self.on_quit)
			]
		ag = gtk.ActionGroup('Actions')
		ag.add_actions(actions)
		self.manager.insert_action_group(ag, 0)
	
	def on_about(self, data):
		dialog = gtk.AboutDialog()
		dialog.set_name('FreeVolume')
		dialog.set_version('0.2')
		dialog.run()
		dialog.destroy()
	
	def on_quit(self, data):
		gtk.main_quit()
		
# ----------------------- Main program -------------------------------------
def main():
	tray = TrayIcon()
	gtk.main()
	
if __name__ == "__main__":
	main()
	sys.exit(0)
